#include <ESP8266WiFi.h>
#include <PubSubClient.h>


// Update these with values suitable for your network.
const char* ssid = "IoTLab_Guest";//"telew_f2b";
const char* password = "Guest@IoT";
const char* mqtt_server = "192.168.1.150";  //"iot.eclipse.org";
#define mqtt_port 1883
//#define MQTT_USER "juliesundar123@gmail.com"
//#define MQTT_PASSWORD "HELENKELLER1"
#define MQTT_SERIAL_PUBLISH_CH "/ESP/"   //"/ic/nm/serialdata/uno/"

WiFiClient wifiClient;

PubSubClient client(wifiClient);

void setup_wifi() {
    delay(10);
    // We start by connecting to a WiFi network
    Serial.println();
    Serial.print("Connecting to ");
    Serial.println(ssid);
    WiFi.begin(ssid, password);
    while (WiFi.status() != WL_CONNECTED) {
      delay(500);
      Serial.print(".");
    }
    randomSeed(micros());
    Serial.println("");
    Serial.println("WiFi connected");
    Serial.println("IP address: ");
    Serial.println(WiFi.localIP());
}

void reconnect() {
  // Loop until we're reconnected
  while (!client.connected()) {
    Serial.print("Attempting MQTT connection...");
    client.publish("outTopic", "hello world");
    // Create a random client ID
    String clientId = "NodeMCUClient-";
    clientId += String(random(0xffff), HEX);
    // Attempt to connect
    if (client.connect(clientId.c_str())) { //,MQTT_USER,MQTT_PASSWORD
      Serial.println("connected");
      //Once connected, publish an announcement...
      client.publish("/ic/presence/nm/", "hello world");
    } else {
      Serial.print("failed, rc=");
      Serial.print(client.state());
      Serial.println(" try again in 5 seconds");
      // Wait 5 seconds before retrying
      delay(5000);
    }
  }
}
void setup() {
  Serial.begin(115200);
  Serial.setTimeout(500);// Set time out for 
  setup_wifi();
  client.setServer(mqtt_server, mqtt_port);
  reconnect();
}

void publishSerialData(char *serialData){
  if (!client.connected()) {
    reconnect();
  }
  client.publish(MQTT_SERIAL_PUBLISH_CH, serialData);
  //client.publish(MQTT_SERIAL_PUBLISH_CH, serialData);
}

void publishMQTTData(char *topic, char *payload){
  if (!client.connected()) {
    reconnect();
  }
  client.publish(topic, payload);
  //client.publish(MQTT_SERIAL_PUBLISH_CH, serialData);
}
void loop() {
   client.loop();
   if (Serial.available() > 0) {
     char bfr1[101];
     memset(bfr1,0, 101);
     Serial.readBytesUntil( '=',bfr1,100);
     char bfr2[100];
     memset(bfr2,0, 101);
     Serial.readBytesUntil( '\n',bfr2,100);
     publishMQTTData(bfr1,bfr2);
     // reset both buffers
   }
 }